org.apache.xml.dtm.ref

## Interface CoroutineParser

Deprecated.
Since the ability to start a parse via the coroutine protocol was not being used and was complicating design. See `IncrementalSAXSource`.

    public interface CoroutineParser

CoroutineParser is an API for parser threads that operate as coroutines. See CoroutineSAXParser and CoroutineSAXParser_Xerces for examples.

<grumble> I'd like the interface to require a specific form for either the base constructor or a static factory method. Java doesn't allow us to specify either, so I'll just document them here:

- public CoroutineParser(CoroutineManager co, int appCoroutine);
- public CoroutineParser createCoroutineParser(CoroutineManager co, int appCoroutine);

</grumble>

### Method Summary

Methods
`java.lang.Object` `doMore(boolean parsemore, int appCoroutine)` Deprecated. doMore() is a simple API which tells the coroutine parser that we need more nodes.
`java.lang.Object` `doParse(InputSource source, int appCoroutine)` Deprecated. doParse() is a simple API which tells the coroutine parser to begin reading from a file.
`void` `doTerminate(int appCoroutine)` Deprecated. doTerminate() is a simple API which tells the coroutine parser to terminate itself.
`CoroutineManager` `getCoroutineManager()` Deprecated.
`int` `getParserCoroutineID()` Deprecated.
`void` `init(CoroutineManager co, int appCoroutineID, XMLReader parser)` Deprecated. Initialize the coroutine parser.
`void` `setContentHandler(ContentHandler handler)` Deprecated. Register a SAX-style content handler for us to output to
`void` `setLexHandler(LexicalHandler handler)` Deprecated. Register a SAX-style lexical handler for us to output to Not all parsers support this...

### Method Detail

#### getParserCoroutineID

    int getParserCoroutineID()

Deprecated.

Returns:
  the coroutine ID number for this CoroutineParser object. Note that this isn't useful unless you know which CoroutineManager you're talking to. Also note that the do...() methods encapsulate the common transactions with the CoroutineParser, so you shouldn't need this in most cases.

#### getCoroutineManager

    CoroutineManager getCoroutineManager()

Deprecated.

Returns:
  the CoroutineManager for this CoroutineParser object. If you're using the do...() methods, applications should only need to talk to the CoroutineManager once, to obtain the application's Coroutine ID.

#### setContentHandler

    void setContentHandler(ContentHandler handler)

Deprecated.
Register a SAX-style content handler for us to output to

#### setLexHandler

    void setLexHandler(LexicalHandler handler)

Deprecated.
Register a SAX-style lexical handler for us to output to Not all parsers support this... %REVIEW% Not called setLexicalHandler because Xalan uses that name internally, which causes subclassing nuisances.

#### doParse

    java.lang.Object doParse(InputSource source,
                           int appCoroutine)

Deprecated.
doParse() is a simple API which tells the coroutine parser to begin reading from a file. This is intended to be called from one of our partner coroutines, and serves both to encapsulate the communication protocol and to avoid having to explicitly use the CoroutineParser's coroutine ID number. %REVIEW% Can/should this unify with doMore? (if URI hasn't changed, parse more from same file, else end and restart parsing...?

Parameters:
  `source` - The InputSource to parse from.
  `appCoroutine` - The coroutine ID number of the coroutine invoking this method, so it can be resumed after the parser has responded to the request.
Returns:
  Boolean.TRUE if the CoroutineParser believes more data may be available for further parsing. Boolean.FALSE if parsing ran to completion. Exception if the parser objected for some reason.

#### doMore

    java.lang.Object doMore(boolean parsemore,
                          int appCoroutine)

Deprecated.
doMore() is a simple API which tells the coroutine parser that we need more nodes. This is intended to be called from one of our partner coroutines, and serves both to encapsulate the communication protocol and to avoid having to explicitly use the CoroutineParser's coroutine ID number.

Parameters:
  `parsemore` - If true, tells the incremental parser to generate another chunk of output. If false, tells the parser that we're satisfied and it can terminate parsing of this document.
  `appCoroutine` - The coroutine ID number of the coroutine invoking this method, so it can be resumed after the parser has responded to the request.
Returns:
  Boolean.TRUE if the CoroutineParser believes more data may be available for further parsing. Boolean.FALSE if parsing ran to completion. Exception if the parser objected for some reason.

#### doTerminate

    void doTerminate(int appCoroutine)

Deprecated.
doTerminate() is a simple API which tells the coroutine parser to terminate itself. This is intended to be called from one of our partner coroutines, and serves both to encapsulate the communication protocol and to avoid having to explicitly use the CoroutineParser's coroutine ID number. Returns only after the CoroutineParser has acknowledged the request.

Parameters:
  `appCoroutine` - The coroutine ID number of the coroutine invoking this method, so it can be resumed after the parser has responded to the request.

#### init

    void init(CoroutineManager co,
            int appCoroutineID,
            XMLReader parser)

Deprecated.
Initialize the coroutine parser. Same parameters could be passed in a non-default constructor, or by using using context ClassLoader and newInstance and then calling init()